import 'my_strings.dart';

class BudPayException implements Exception {
  String? message;

  BudPayException(this.message);

  @override
  String toString() {
    if (message == null) return Strings.unKnownError;
    return message!;
  }
}

class AuthenticationException extends BudPayException {
  AuthenticationException(String message) : super(message);
}

class CardException extends BudPayException {
  CardException(String message) : super(message);
}

class ChargeException extends BudPayException {
  ChargeException(String? message) : super(message);
}

class InvalidAmountException extends BudPayException {
  int amount = 0;

  InvalidAmountException(this.amount)
      : super('$amount is not a valid '
            'amount. only positive non-zero values are allowed.');
}

class InvalidEmailException extends BudPayException {
  String? email;

  InvalidEmailException(this.email) : super('$email  is not a valid email');
}

class BudPaySdkNotInitializedException extends BudPayException {
  BudPaySdkNotInitializedException(String message) : super(message);
}

class ProcessingException extends ChargeException {
  ProcessingException()
      : super(
            'A transaction is currently processing, please wait till it concludes before attempting a  charge.');
}
