import 'package:flutter/material.dart';

class Submitbutton extends StatelessWidget {
  final String name;
  final Function press;
  final bool isloading;
  final Color buttoncolor, textcolor;
  const Submitbutton(
      {Key? key,
      required this.name,
      this.isloading = false,
      required this.press,
      this.buttoncolor = const Color(0xff6C30F4),
      this.textcolor = Colors.white})
      : super(key: key);

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      child: Container(
        decoration: BoxDecoration(
            borderRadius: const BorderRadius.all(Radius.circular(15)),
            color: buttoncolor),
        height: 65,
        width: MediaQuery.of(context).size.width - 70,
        padding: const EdgeInsets.symmetric(vertical: 15),
        margin: const EdgeInsets.symmetric(horizontal: 10, vertical: 10),
        alignment: Alignment.center,
        child: Text(
          name,
          style: TextStyle(color: textcolor, fontSize: 20),
        ),
      ),
      onTap: () {
        press();
      },
    );
  }
}
