import 'dart:io';

import 'package:http/http.dart' as http;

import 'env_variable.dart';

var onFailure = '{"success":false,"message":"No internet connection"}';

Future<String> postApiCallTokenized(jsonBody, endpoint, publicKey) async {
  var res = onFailure;

  if (debug) {
    print(jsonBody);
  }

  try {
    http.Response response = await http.post(parseURL(endpoint),
        body: jsonBody,
        headers: {HttpHeaders.authorizationHeader: "Bearer $publicKey"});
    res = response.body;
    if (debug) {
      print("method: $res");
    }
  } catch (Exception) {
    // nonetwork();

    if (debug) {
      print(Exception);
    }
  }
  return res;
}

Future<String> getApiCallTokenized(endpoint, publicKey) async {
  var res = onFailure;
  try {
    http.Response response = await http.get(parseURL(endpoint), headers: {
      HttpHeaders.contentTypeHeader: "application/json",
      HttpHeaders.acceptHeader: "application/json",
      HttpHeaders.authorizationHeader: "Bearer $publicKey"
    });

    res = response.body;
    if (debug) {
      print("method: $res");
    }
  } catch (Exception) {
    if (debug) {
      print(Exception);
    }
  }
  return res;
}
